package com.wissamfawaz;

public class ArrayBasedQueue implements Queue {
	private Object[] arr;
	private int front, rear, size;
	private StringBuilder sb;
	
	public ArrayBasedQueue(int capacity) {
		arr = new Object[capacity];
		front = rear = size = 0;
		sb = new StringBuilder();
	}

	@Override
	public int size() {
		return size;
	}

	@Override
	public boolean isEmpty() {
		return (size == 0);
	}

	@Override
	public void enqueue(Object element) throws QueueException {
		if(size() == arr.length) {
			throw new QueueException("Queue is full!");			
		}
		
		arr[rear] = element;
		rear = (rear + 1) % arr.length;
		size++;
		sb.append(element  +" ");

	}

	@Override
	public Object dequeue() throws QueueException {
		if(isEmpty()) {
			throw new QueueException("Queue is empty!");
		}
		
		Object toReturn = arr[front]; 
		arr[front] = null;
		
		size--;
		front = (front + 1) % arr.length;
		sb.delete(0, toReturn.toString().length() + 1);
		
		return toReturn;
	}

	@Override
	public Object front() throws QueueException {
		if(isEmpty()) {
			throw new QueueException("Queue is empty!");
		}
		return arr[front];
	}
	
	public String toString() {
		return sb.toString();
	}

}
